
#property copyright "Copyright 2016, MecMan & GigaBrainy"
#property version   "1.00"
#property strict


extern color    EApanelColor            = clrFireBrick;
extern string   EAcomment               = "VSW";
extern int      EAmagic                 = 223900;
       bool     CheckNewBarOnAllPairs   = true;

extern string   _BASKET_SETTINGS_       = "-----------------------------------------------------------------------------------------------";
extern bool     StartNewBasket          = true;
extern double   BaseLot                 = 0.10;

       double   BetterEntryPips         = 45;
extern int      HourEnd_OnFriday        = 15;

extern bool     CloseOnGlobalProfit     = false;
extern double   CloseOnGlobalProfit_USD = 40;

extern string   _PROFIT_TARGETS_        = "-------------------------------------------------------------------";
extern double   SLpips                  = 90;
extern double   TPpips                  = 200;

extern string   _TRAILING_PROFITS_      = "-------------------------------------------------------------------";
extern bool     Trailing_IsEnabled      = true;
extern int      TrailStartPips          =8;
extern int      Trailpips               =2;
extern int      TrailStepPips           =1;

extern string   _VERTEX_INDI_           = "-------------------------------------------------------------------";
extern double   Vertex_TF1              = 30;
extern double   Vertex_TF2              = 60;
extern double   Vertex_EntryThreshold   = 10;
extern double   Vertex_ExitThreshold    = 2.5;



   int      Trailing_Pips1          = 18; // Take Profit 1 in Points
   int      Trailing_Pips2          = 35; // Take Profit 2 in Points
   int      Trailing_Pips3          = 60; // Take Profit 3 in Points
   int      Trailing_Pips4          = 100; // Take Profit 4 in Points
   int      Trailing_Pips5          = 150; // Take Profit 5 in Points
   int      Trailing_Pips6          = 200; // Take Profit 6 in Points
   int      Trailing_Pips7          = 250; // Take Profit 7 in Points 

   string   _ENTRY_FILTER_          = "-------------------------------------------------------------------";
   int      Entry_Stoch_TF          = 60;
   int      Entry_Stoch_K           = 5;
   int      Entry_Stoch_D           = 4;
   int      Entry_Stoch_Slow        = 3;
   int      Entry_Stoch_Shift       = 0;


extern string   _TRADING_PAIRS_         = " (leave blank to ignore) ----------------------------------------------------------------------";
extern string   Pair_01                 = "AUDCAD";
extern string   Pair_02                 = "AUDCHF";
extern string   Pair_03                 = "AUDJPY";
extern string   Pair_04                 = "AUDNZD";
extern string   Pair_05                 = "AUDUSD";
extern string   Pair_06                 = "CADCHF";
extern string   Pair_07                 = "CADJPY";
extern string   Pair_08                 = "CHFJPY";
extern string   Pair_09                 = "EURAUD";
extern string   Pair_10                 = "EURCAD";
extern string   Pair_11                 = "EURCHF";
extern string   Pair_12                 = "EURGBP";
extern string   Pair_13                 = "EURJPY";
extern string   Pair_14                 = "EURNZD";
extern string   Pair_15                 = "EURUSD";
extern string   Pair_16                 = "GBPAUD";
extern string   Pair_17                 = "GBPCAD";
extern string   Pair_18                 = "GBPCHF";
extern string   Pair_19                 = "GBPJPY";
extern string   Pair_20                 = "GBPNZD";
extern string   Pair_21                 = "GBPUSD";
extern string   Pair_22                 = "NZDCAD";
extern string   Pair_23                 = "NZDCHF";
extern string   Pair_24                 = "NZDJPY";
extern string   Pair_25                 = "NZDUSD";
extern string   Pair_26                 = "USDCAD";
extern string   Pair_27                 = "USDCHF";
extern string   Pair_28                 = "USDJPY";

extern int      MaxConcurrentPairs      = 10;

extern string   _HISTORY_STATS_         = "-----------------------------------------------------------------------------------------------";
extern string   CheckHistoryAfter       = "2016.09.30 00:00"; 

double    MassiveBasketFloating;
bool      NewBar_AllPairsCheck;

double    MyRegr[500];
double    ATRregression;

double    mpb;
double    mps;

datetime  lastbar;
datetime  lastbar_m1;
datetime  lastbar_m5;
datetime  lastbar_m15;
datetime  lastbar_m30;
datetime  lastbar_H4;
datetime  lastbar_H1;

double    pt;

int       Lot_Dec;
int       nb;
int       ns;

double    History_Lots            = 0;
double    History_MaxLots         = 0;
int       History_TotalTrades     = 0;
double    History_TotalProfitLoss = 0;
double    History_Pips            = 0;

double    History_AvgDuration = 0;
double    History_WinPerc     = 0;
double    History_LossPerc    = 0;
double    History_WinPips     = 0;
double    History_LossPips    = 0;

string    OPsymbols[28];
int       QueueTot=0;

double    OpenLots_Buy = 0;
double    OpenLots_Sell= 0;

string    strEAmagic;
int       mgclen;

string    HAS_TF_desc;
string    RSI_TF_desc;

int       Shift=1;
datetime  BasketStartTime;


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
{
//----

   lastbar     = iTime(Symbol(),0,0);
   lastbar_m1  = iTime(Symbol(),PERIOD_M1,0);
   lastbar_m5  = iTime(Symbol(),PERIOD_M5,0);
   lastbar_m15 = iTime(Symbol(),PERIOD_M15,0);
   lastbar_m30 = iTime(Symbol(),PERIOD_M30,0);
   lastbar_H1  = iTime(Symbol(),PERIOD_H1,0);
   lastbar_H4  = iTime(Symbol(),PERIOD_H4,0);
   

   //--------------------------------------------------------------------- 
   //Background
   //--------------------------------------------------------------------- 

   if (ObjectFind("Background")==-1)
   {
       ObjectCreate("Background",OBJ_LABEL,0,0,0);
       ObjectSet("Background",OBJPROP_CORNER,0);
       ObjectSet("Background",OBJPROP_BACK,FALSE);
       ObjectSet("Background",OBJPROP_YDISTANCE,14);
       ObjectSet("Background",OBJPROP_XDISTANCE,0);
   }

   ObjectSetText("Background","g",130,"Webdings",EApanelColor);

   if (IsTesting()) 
   {
      CheckNewBarOnAllPairs = false;
      CheckHistoryAfter = "1999.07.31 00:00"; 

   }      
   
//----
   return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
{

//----
   if (!IsVisualMode())
   {
      Comment("");
      ObjectDelete("Background");
      
      if (IsTesting())
      {
         HistoryResults(true);
         
         Print("------------------------------------------------------------------");
         Print("---------->> TOT.LOTS  :  ", History_Lots);
         Print("---------->> TOT.PIPS  :  ", History_Pips);
         Print("---------->> TOT.PROFIT:  ", History_TotalProfitLoss);
         Print("---------->> TOT.TRADES:  ", History_TotalTrades);
      }
   }
//----

}

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
void OnTick()
{
//----
   
   strEAmagic = DoubleToStr(EAmagic,0);
   mgclen     = StringLen(strEAmagic);

   double price_BID ;
   double price_ASK ;
      
//   bool   new_bar_cur = NewBar();
   bool   new_bar_m1   = NewBar_m1();   
   bool   new_bar_m5   = NewBar_m5();   
   bool   new_bar_m15  = NewBar_m15();   
   bool   new_bar_m30  = NewBar_m30();   
   bool   new_bar_h1   = NewBar_H1(); // NewBar_H4();

   
   if (new_bar_m30 && CheckNewBarOnAllPairs) 
   {
      new_bar_m30 = false;
      NewBar_AllPairsCheck = true;
   }
   

   if (new_bar_m1 && NewBar_AllPairsCheck && CheckNewBarOnAllPairs)
   {
      string CheckCross;
      int    CurPairCandleTime = TimeMinute(iTime(Symbol(),PERIOD_M30,0));      
      int    OtherPairCandleTime;      
      int    NewCandles=0;
      int    EligiblePairs=0;
      
      for (int k=1;k<=28;k++)
      {
         CheckCross = PairToTrade(k);
         if (CheckCross=="") continue;

         EligiblePairs++;
         
         
         OtherPairCandleTime = TimeMinute(iTime(CheckCross,PERIOD_M30,0));
         
         Print("-->> Checking candle time (",CurPairCandleTime,") on ",Symbol(), " with ",CheckCross," (",OtherPairCandleTime,") ...");
         
         if (CurPairCandleTime==OtherPairCandleTime) NewCandles++;   
      }
      
      if (NewCandles>=EligiblePairs) 
      {
         NewBar_AllPairsCheck=false;
         new_bar_m30 = true;
         Print("-->> New M30 candle is ready on ALL Pairs.");
      }
   }


   bool FridayOK=DayOfWeek()!=0;
   if (DayOfWeek()==5 && Hour()>HourEnd_OnFriday) FridayOK=false;
   
   if (new_bar_m1)
   {
      ///////////////////////////////
      if (IsDemo()) CloseOldForward();
      HistoryResults(false);
      ///////////////////////////////
   }

   if (new_bar_m1) CheckValidSL();
   
   bool ChristmasTime = false; //(Month()==12 && Day()>10) || (Month()==1 && Day()<5);
   

   if (new_bar_m30 && !ChristmasTime)
   {

      int cntOPsymb = CountOpenSymbols();
                       
      for (int k=1;k<=28;k++)
      {

         string CheckCross = PairToTrade(k);
         if (CheckCross=="") continue;
         
         if (MarketInfo(CheckCross, MODE_MINLOT) < 1.0)    Lot_Dec = 1;
         if (MarketInfo(CheckCross, MODE_MINLOT) < 0.1)    Lot_Dec = 2;
         if (MarketInfo(CheckCross, MODE_MINLOT) < 0.01)   Lot_Dec = 3;
         if (MarketInfo(CheckCross, MODE_MINLOT) < 0.001)  Lot_Dec = 4;
         if (MarketInfo(CheckCross, MODE_MINLOT) < 0.0001) Lot_Dec = 5;

         int Nsell = OpenPos(CheckCross, OP_SELL);
         int Nbuy  = OpenPos(CheckCross, OP_BUY);
                              
         bool EntryLONG  = false;
         bool EntrySHORT = false;
                  
         bool goLong_TF1;
         bool goLong_TF2;
         bool goShort_TF1;
         bool goShort_TF2;

         double TF1_RedL1 = iCustom(CheckCross,Vertex_TF1,"vertex_mod_3.01",0,1);
         double TF1_RedL2 = iCustom(CheckCross,Vertex_TF1,"vertex_mod_3.01",0,2);
         double TF1_RedL3 = iCustom(CheckCross,Vertex_TF1,"vertex_mod_3.01",0,3);
         double TF1_RedL4 = iCustom(CheckCross,Vertex_TF1,"vertex_mod_3.01",0,4);

         double TF1_BBup1 = iCustom(CheckCross,Vertex_TF1,"vertex_mod_3.01",2,1);
         double TF1_BBup2 = iCustom(CheckCross,Vertex_TF1,"vertex_mod_3.01",2,2);
         double TF1_BBdw1 = iCustom(CheckCross,Vertex_TF1,"vertex_mod_3.01",3,1);
         double TF1_BBdw2 = iCustom(CheckCross,Vertex_TF1,"vertex_mod_3.01",3,2);

         double TF2_RedL1 = iCustom(CheckCross,Vertex_TF2,"vertex_mod_3.01",0,1);
         double TF2_RedL2 = iCustom(CheckCross,Vertex_TF2,"vertex_mod_3.01",0,2);
         double TF2_RedL3 = iCustom(CheckCross,Vertex_TF2,"vertex_mod_3.01",0,3);
         double TF2_RedL4 = iCustom(CheckCross,Vertex_TF2,"vertex_mod_3.01",0,4);
         
         double TF2_BBup1 = iCustom(CheckCross,Vertex_TF2,"vertex_mod_3.01",2,1);
         double TF2_BBup2 = iCustom(CheckCross,Vertex_TF2,"vertex_mod_3.01",2,2);
         double TF2_BBdw1 = iCustom(CheckCross,Vertex_TF2,"vertex_mod_3.01",3,1);
         double TF2_BBdw2 = iCustom(CheckCross,Vertex_TF2,"vertex_mod_3.01",3,2);
         
         bool ExitLONG  = false;
         bool ExitSHORT = false;

         ExitLONG  = (TF1_BBup1< Vertex_ExitThreshold) || (TF2_BBup1< Vertex_ExitThreshold); 
         ExitSHORT = (TF1_BBdw1>-Vertex_ExitThreshold) || (TF2_BBdw1>-Vertex_ExitThreshold);
         

         goShort_TF1 = (TF1_RedL1>Vertex_EntryThreshold || TF1_RedL2>Vertex_EntryThreshold || TF1_RedL3>Vertex_EntryThreshold || TF1_RedL4>Vertex_EntryThreshold) && (TF1_RedL2>TF1_BBup2 && TF1_RedL1<TF1_BBup1);
         goLong_TF1  = (TF1_RedL1<-Vertex_EntryThreshold || TF1_RedL2<-Vertex_EntryThreshold || TF1_RedL3<-Vertex_EntryThreshold || TF1_RedL4<-Vertex_EntryThreshold) && (TF1_RedL2<TF1_BBdw2 && TF1_RedL1>TF1_BBdw1);

         goShort_TF2 = (TF2_RedL1>Vertex_EntryThreshold || TF2_RedL2>Vertex_EntryThreshold || TF2_RedL3>Vertex_EntryThreshold || TF2_RedL4>Vertex_EntryThreshold); // && (TF2_RedL2>TF2_BBup2 && TF2_RedL1<TF2_BBup1);
         goLong_TF2  = (TF2_RedL1<-Vertex_EntryThreshold || TF2_RedL2<-Vertex_EntryThreshold || TF2_RedL3<-Vertex_EntryThreshold || TF2_RedL4<-Vertex_EntryThreshold); // && (TF2_RedL2<TF2_BBdw2 && TF2_RedL1>TF2_BBdw1);

         
         if (cntOPsymb<MaxConcurrentPairs && StartNewBasket && FridayOK)
         {               
            EntryLONG  = goLong_TF1 && goLong_TF2 && Nbuy<1;
            EntrySHORT = goShort_TF1 && goShort_TF2 && Nsell<1;
         }
                  
                  
         bool BetterBuy;
         bool BetterSell;
         
         if (EntryLONG)
            BetterBuy =  BestEntry(CheckCross,OP_BUY,BetterEntryPips);

         if (EntrySHORT)
            BetterSell = BestEntry(CheckCross,OP_SELL,BetterEntryPips);
                  
         double Lots=0;   
         int    tk;   
         double LotDiff;   
         double Lmin = MarketInfo(CheckCross,MODE_MINLOT);   
                  

         if (EntrySHORT || ExitLONG)
         {
            CloseAllByType(CheckCross,OP_BUY,false);
         }

         if (EntrySHORT && BetterSell) 
         {
            
            ////////////////////////////
            //    Fire SELL Trade     //
            ////////////////////////////
            Lots = BaseLot;                                    
            Lots = NormalizeDouble(Lots,Lot_Dec);   
            
            
            WaitReadyStatus();         
            
            price_BID = MarketInfo(CheckCross,MODE_BID);
            tk = OrderSend(CheckCross,OP_SELL,Lots,price_BID,2,0,0,EAcomment,EAmagic,0,Red);         
            
            if (tk<=0) 
            {         
               Alert("WARNING: Cannot open SELL on "+CheckCross+" !!!");      

               while (tk<=0)
               {
                  WaitReadyStatus();         
                  
                  price_BID = MarketInfo(CheckCross,MODE_BID);
                  tk = OrderSend(CheckCross,OP_SELL,Lots,price_BID,2,0,0,EAcomment,EAmagic,0,Red);
                  
                  if (!IsTesting()) Print("--->> Trying to Open " + CheckCross + " SELL ("+Lots+ " lots)...");
                  
                  if (tk<=0) Sleep(250);
               }
            }
            
            cntOPsymb   = CountOpenSymbols();

         }
   

         if (EntryLONG || ExitSHORT)
         {
            CloseAllByType(CheckCross,OP_SELL,false);
         }
      
         if (EntryLONG && BetterBuy) 
         {

            ////////////////////////////
            //     Fire BUY Trade     //
            ////////////////////////////
            
            Lots = BaseLot;      
            Lots = NormalizeDouble(Lots,Lot_Dec);   
   
            WaitReadyStatus();         
            
            price_ASK = MarketInfo(CheckCross,MODE_ASK);
            tk = OrderSend(CheckCross,OP_BUY,Lots,price_ASK,2,0,0,EAcomment,EAmagic,0,Blue);         
            
            if (tk<=0) 
            {         
               Alert("WARNING: Cannot open BUY on "+CheckCross+" !!!");      

               while (tk<=0)
               {
                  WaitReadyStatus();         
                  
                  price_ASK = MarketInfo(CheckCross,MODE_ASK);
                  tk = OrderSend(CheckCross,OP_BUY,Lots,price_ASK,2,0,0,EAcomment,EAmagic,0,Blue);         
                  
                  if (!IsTesting()) Print("--->> Trying to Open " + CheckCross + " BUY ("+Lots+ " lots)...");
                  
                  if (tk<=0) Sleep(250);
               }
            }
            
            cntOPsymb   = CountOpenSymbols();
         }
      }
   }
      
   string MySymbol    = "";

   int    cntOPsymb   = CountOpenSymbols();
   double CurFloating = CalcFloating();

   if (!IsTesting() || IsVisualMode())
   {   
      double PayOff;
      if (History_TotalTrades>0) PayOff = History_Pips/History_TotalTrades;

      string LastLine1 = "History Trades   :  "+DoubleToStr(History_TotalTrades,0) + "  ("+DoubleToStr(History_Pips,2)+" pips)";
      string LastLine2 = "History PayOff  :  "+DoubleToStr(PayOff,2) + " pips";      
      string LastLine3 = "History Duration:   "+DoubleToStr(History_AvgDuration,2)+ "  (min.)";

      string LastLine4 = "History Tot. Lots:  "+DoubleToStr(History_Lots,2)+"  ("+DoubleToStr(History_MaxLots,2)+" max)";
      string LastLine5 = "History Win %   :  "+DoubleToStr(History_WinPerc,1)+ "%  ("+DoubleToStr(History_WinPips,2)+" pips)";
      string LastLine6 = "History Loss %  :  "+DoubleToStr(History_LossPerc,1)+ "%  ("+DoubleToStr(History_LossPips,2)+" pips)";
      string LastLine7 = "History Profit     :  "+DoubleToStr(History_TotalProfitLoss,2)+ " "+AccountCurrency();
         
      Comment("-------------------------------------------------------"
          + "\n            Vertex Swinger v.1.00                      " 
          + "\n-------------------------------------------------------"
          + "\nMagic/comment :  "+ strEAmagic + " {" + EAcomment+"}"
          + "\nTrading pairs     :   "+DoubleToStr(cntOPsymb,0)+ " opened"
          + "\nCurrent floating  :  "+DoubleToStr(CurFloating,2)+" "+AccountCurrency()
          + "\n-------------------------------------------------------"
          + "\n"+LastLine1 
          + "\n"+LastLine2 
          + "\n"+LastLine3 
          + "\n"+LastLine4
          + "\n"+LastLine5
          + "\n"+LastLine6
          + "\n"+LastLine7
          );

   }
   
   for (int cnt=1;cnt<=cntOPsymb;cnt++)
   {
      MySymbol = OPsymbols[cnt];
   
      if (MySymbol=="") continue;
   
      if (MarketInfo(MySymbol, MODE_DIGITS) <= 3) 
         pt = 0.01;
      else 
         pt = 0.0001;

      if (StringFind(MySymbol,"XAU")>-1)
         pt = 0.10;   
         
      if (MarketInfo(MySymbol, MODE_MINLOT) < 1.0)    Lot_Dec = 1;
      if (MarketInfo(MySymbol, MODE_MINLOT) < 0.1)    Lot_Dec = 2;
      if (MarketInfo(MySymbol, MODE_MINLOT) < 0.01)   Lot_Dec = 3;
      if (MarketInfo(MySymbol, MODE_MINLOT) < 0.001)  Lot_Dec = 4;
      if (MarketInfo(MySymbol, MODE_MINLOT) < 0.0001) Lot_Dec = 5;

      
      nb = OpenPos(MySymbol, OP_BUY);
      ns = OpenPos(MySymbol, OP_SELL);
   

      mps=0;
      mpb=0;
   
      if (nb>0) 
         mpb = MedianPrice(MySymbol,OP_BUY,0,0);   
      else
         SetLine(MySymbol, OP_BUY,0);
            
      if (ns>0) 
         mps = MedianPrice(MySymbol,OP_SELL,0,0);
      else
         SetLine(MySymbol, OP_SELL,9999);
         
      
      double pb=0;
      double ps=0;
      
      if (nb>0) 
         pb = CurrentProfit(MySymbol,OP_BUY);  
                     
      if (ns>0) 
         ps = CurrentProfit(MySymbol,OP_SELL);


      if (pb<=0)
         SetLine(MySymbol, OP_BUY,0);
      
      if (ps<=0)      
         SetLine(MySymbol, OP_SELL,9999);
      
   
      double sls=9999;
      double slb=0;
      
      if (Trailing_IsEnabled && new_bar_m1) 
      {
/*

         BasketStartTime = OldestPos(MySymbol);
         
         if ((TimeCurrent()-BasketStartTime)>3*24*3600)
         {
            if (ps+pb>0) 
            {
               CloseAllByType(MySymbol,OP_BUY,false);
               CloseAllByType(MySymbol,OP_SELL,false);
               
               return;
            }
         }
         
         if (ns>0)
         {  
            double mps = MedianPrice(MySymbol,OP_SELL,0,0);
            
            MoveToBE(MySymbol, OP_SELL, mps, Trailing_Pips1);
            MoveToBE(MySymbol, OP_SELL, mps, Trailing_Pips2);
            MoveToBE(MySymbol, OP_SELL, mps, Trailing_Pips3);
            MoveToBE(MySymbol, OP_SELL, mps, Trailing_Pips4);
            MoveToBE(MySymbol, OP_SELL, mps, Trailing_Pips5);
            MoveToBE(MySymbol, OP_SELL, mps, Trailing_Pips6);
            MoveToBE(MySymbol, OP_SELL, mps, Trailing_Pips7);
         }

         if (nb>0)
         {  
            double mpb = MedianPrice(MySymbol,OP_BUY,0,0);
            
            MoveToBE(MySymbol, OP_BUY, mpb, Trailing_Pips1);
            MoveToBE(MySymbol, OP_BUY, mpb, Trailing_Pips2);
            MoveToBE(MySymbol, OP_BUY, mpb, Trailing_Pips3);
            MoveToBE(MySymbol, OP_BUY, mpb, Trailing_Pips4);
            MoveToBE(MySymbol, OP_BUY, mpb, Trailing_Pips5);
            MoveToBE(MySymbol, OP_BUY, mpb, Trailing_Pips6);
            MoveToBE(MySymbol, OP_BUY, mpb, Trailing_Pips7);
         }
*/
      
         
         if (nb+ns>0) 
         {
   
            price_BID = MarketInfo(MySymbol,MODE_BID);
            price_ASK = MarketInfo(MySymbol,MODE_ASK);
   
      
            if (ns>0 && ps>0)
            {
               HiddenTrailing(MySymbol,"SHORT");
               
               sls = GetLine(MySymbol,OP_SELL);
               if (price_ASK>=sls && sls!=0) 
               {               
                  Print("-------------->> Close ALL by hidden Trailing (short).....");
                  CloseAllByType(MySymbol,OP_SELL,false);
                  SetLine(MySymbol,OP_SELL,9999);
      
               }   
            }
      
   
            if (nb>0 && pb>0)
            {
               HiddenTrailing(MySymbol,"LONG");
               
               slb = GetLine(MySymbol,OP_BUY);
               if (price_BID<=slb) 
               {
                  Print("-------------->> Close ALL by hidden Trailing (long).....");
                  CloseAllByType(MySymbol,OP_BUY,false);
                  SetLine(MySymbol,OP_BUY,0);
                  
               }
            }   
         }
               
      }
   
            
   }
   
   
   if (CloseOnGlobalProfit)
   {
      if (CalcFloating()>CloseOnGlobalProfit_USD) CloseAllBasket();
   }
               
   return;

}

//+------------------------------------------------------------------+

bool NewBar_H4()
{
   datetime curbar = iTime(Symbol(),PERIOD_H4,0);
   if (lastbar_H4==0) lastbar_H4 = curbar;

   if (lastbar_H4!=curbar)
   {
      lastbar_H4=curbar;
      return (true);
   }
   else
   {
      return(false);
   }
}

bool NewBar_H1()
{
   datetime curbar = iTime(Symbol(),PERIOD_H1,0);
   if (lastbar_H1==0) lastbar_H1 = curbar;

   if (lastbar_H1!=curbar)
   {
      lastbar_H1=curbar;
      return (true);
   }
   else
   {
      return(false);
   }
}


bool NewBar()
{
   datetime curbar = iTime(Symbol(),0,0);
   if (lastbar==0) lastbar = curbar;

   if (lastbar!=curbar)
   {
      lastbar=curbar;
      return (true);
   }
   else
   {
      return(false);
   }
}

bool NewBar_m1()
{
   datetime curbar = iTime(Symbol(),PERIOD_M1,0);
   if (lastbar_m1==0) lastbar_m1 = curbar;

   if (lastbar_m1!=curbar)
   {
      lastbar_m1=curbar;
      return (true);
   }
   else
   {
      return(false);
   }
}

bool NewBar_m5()
{
   datetime curbar = iTime(Symbol(),PERIOD_M5,0);
   if (lastbar_m5==0) lastbar_m5 = curbar;

   if (lastbar_m5!=curbar)
   {
      lastbar_m5=curbar;
      return (true);
   }
   else
   {
      return(false);
   }
}

bool NewBar_m15()
{
   datetime curbar = iTime(Symbol(),PERIOD_M15,0);
   if (lastbar_m15==0) lastbar_m15 = curbar;

   if (lastbar_m15!=curbar)
   {
      lastbar_m15=curbar;
      return (true);
   }
   else
   {
      return(false);
   }
}

bool NewBar_m30()
{
   datetime curbar = iTime(Symbol(),PERIOD_M30,0);
   if (lastbar_m30==0) lastbar_m30 = curbar;

   if (lastbar_m30!=curbar)
   {
      lastbar_m30=curbar;
      return (true);
   }
   else
   {
      return(false);
   }
}

//+------------------------------------------------------------------+

//+------------------------------------------------------------------+

int OpenPos(string symbol_name, int type)
{
  
  OpenLots_Buy = 0;
  OpenLots_Sell= 0;
  
  int total=0;
  for(int i=0; i<OrdersTotal(); i++)
  {
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
      {
         if (OrderMagicNumber()==EAmagic && OrderSymbol()==symbol_name)
         {
            if (OrderType()==type) total++;
            
            if (OrderType()==OP_BUY)  OpenLots_Buy = OpenLots_Buy + OrderLots();
            if (OrderType()==OP_SELL) OpenLots_Sell= OpenLots_Sell+ OrderLots();
         }
      }
  }
  return(total);
}

//+------------------------------------------------------------------+

double TotLots(string symbol_name, int type)
{
  double total=0;
  for(int i=0; i<OrdersTotal(); i++)
  {
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
      {
         if (OrderMagicNumber()==EAmagic && OrderType()==type && OrderSymbol()==symbol_name)
         
            total=total + OrderLots();
      }
  }
  return(total);
}

//+------------------------------------------------------------------+

double CurrentProfit(string symbol_name, int type)
{

  double all=0;
  
  for(int i=OrdersTotal()-1; i>=0; i--)
  {
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
      {
         if (OrderSymbol()==symbol_name) 
         {      
            if (OrderType()==type && OrderMagicNumber()==EAmagic)
               all=all+OrderProfit()+OrderCommission()+OrderSwap();   

         }  
      }
  }
  
  return(all);  

} 


////////////////////////////////////////////////////////////////////////////////////////////////////////
void CloseAll(string symbol_name)
{ 
      
   int cnt;   
   int total = OrdersTotal()-1;
         
   WaitReadyStatus();
               
   total = OrdersTotal()-1;
   for (cnt = total ; cnt >= 0; cnt--) 
   { 
      if (OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES))
      {

         if (OrderSymbol()==symbol_name || symbol_name=="") 
         {      
            if ( OrderMagicNumber()==EAmagic )
            {   

               if (OrderType()==OP_BUY)               
                  OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_BID),2,Blue);

               if (OrderType()==OP_SELL)               
                  OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_ASK),2,Red);

               if (OrderType()==OP_SELLSTOP || OrderType()==OP_BUYSTOP)               
                  OrderDelete(OrderTicket());
            }
         }  
         
      }
   }
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
void CloseAllByType(string symbol_name, int type, bool JustProfit)
{ 
      
   int cnt;   
   int total = OrdersTotal()-1;
   
   double MinProfit = -999999999;
   
   if (JustProfit) MinProfit = 0;
   
         
   WaitReadyStatus();
               
   total = OrdersTotal()-1;
   for (cnt = total ; cnt >= 0; cnt--) 
   { 
      if (OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES))
      {

         if (OrderSymbol()==symbol_name && OrderMagicNumber()==EAmagic)
         {   

            if (OrderType()==type && OrderType()==OP_BUY && (OrderProfit()>MinProfit))               
               OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_BID),2,Blue);

            if (OrderType()==type && OrderType()==OP_SELL && (OrderProfit()>MinProfit))               
               OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_ASK),2,Red);

         }
         
      }
   }
}


void WaitReadyStatus()
{
  
   if (!IsTesting()) 
   {
       while ((!IsTradeAllowed()) || (!IsConnected()))
       {
          Sleep(100);
          RefreshRates();
       }
   } 

}


////////////////////////////////////////////////////////////////////////////////////////////////////////
int CountOpenSymbols()
{ 
   
   string strSymbols="";   
   int cntSymbols=0;

   int cnt;
   int total = OrdersTotal()-1;


   for (cnt = 0 ; cnt <28; cnt++) 
      OPsymbols[cnt]="";
   
         
   for (cnt = total ; cnt >= 0; cnt--) 
   { 
      if (OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES))
      {
         if (OrderMagicNumber()==EAmagic) 
         {      
            if (StringFind(strSymbols,OrderSymbol())==-1) 
            {      
               cntSymbols++;              
               
               OPsymbols[cntSymbols]=OrderSymbol();
               strSymbols = strSymbols + "@" + OrderSymbol();
            }  

         }  
         
      }
   }

   return(cntSymbols); 
}


void SetLine(string symbol_name, int type, double price)
{
   string ObjName;
   int ObjClr;   
   
   if (type==OP_BUY)   
   {
      ObjName = symbol_name+"_HiddenSL_Buy"+EAmagic;
      ObjClr = Aqua;
   }
   else
   {   
      ObjName = symbol_name+"_HiddenSL_Sell"+EAmagic;
      ObjClr = Magenta;
   }


   if (ObjectFind(ObjName)==-1)
   {
      ObjectCreate (ObjName, OBJ_HLINE, 0, 0, price);
      ObjectSet    (ObjName, OBJPROP_COLOR, ObjClr);
      ObjectSet    (ObjName, OBJPROP_STYLE, STYLE_SOLID);
      ObjectSetText(ObjName, "Price: "+ DoubleToStr(price,MarketInfo(symbol_name,MODE_DIGITS)), 7, "System", ObjClr);
   }
   else
   {
      ObjectSet(ObjName,OBJPROP_PRICE1, price);
   }
}

void DelLine(string symbol_name,int type)
{
   string ObjName;
   
   if (type==OP_BUY)   
   {
      ObjName = symbol_name+"_HiddenSL_Buy"+EAmagic;
   }
   else
   {   
      ObjName = symbol_name+"_HiddenSL_Sell"+EAmagic;
   }

   ObjectDelete(ObjName);
}

double GetLine(string symbol_name,int type)
{
   string ObjName;
   int    ObjType;
   
   if (type==OP_BUY)   
   {
      ObjName = symbol_name+"_HiddenSL_Buy"+EAmagic;
      ObjType = OP_BUY;
   }
   else
   {   
      ObjName = symbol_name+"_HiddenSL_Sell"+EAmagic;
      ObjType = OP_SELL;
   }

   if (ObjectFind(ObjName)==-1)
   {
      if (ObjType==OP_BUY)
      {
         SetLine(symbol_name,ObjType,0);
         return(0);
      }  

      if (ObjType==OP_SELL)
      {
         SetLine(symbol_name,ObjType,9999);
         return(9999);
      }  
   }
   else
   {
      return(ObjectGet(ObjName,OBJPROP_PRICE1));
   }

   return(0);
}

//====================================================================================================================================================//
void HistoryResults(bool ForceCalc)
{
  
  if (IsTesting() && !ForceCalc) return;
  
  
  //---------------------------------------------------------------------
  
  History_TotalTrades     = 0;
  History_TotalProfitLoss = 0;
  History_Pips            = 0;
  History_Lots            = 0;
  History_MaxLots         = 0; 
  History_AvgDuration     = 0;
  History_WinPerc         = 0;
  History_WinPips         = 0;
  History_LossPerc        = 0;
  History_LossPips        = 0;
  
  //---------------------------------------------------------------------
  

  double WinPips;
  double LossPips;
  double Pips;
  double WinTrades;
  double LossTrades;
  double tmpProfit;
  string tmpVarName;
  double tmpBanked;
  int    BasketLastStart;
  
  for (int i=0; i<OrdersHistoryTotal(); i++) 
  {  
      if (OrderSelect(i,SELECT_BY_POS,MODE_HISTORY))
      {
         if ((OrderMagicNumber()==EAmagic))
         { 
            
            if (OrderOpenTime()>StrToTime(CheckHistoryAfter))
            {
               if ((OrderType()==OP_BUY)||(OrderType()==OP_SELL))
               {
                  History_TotalTrades++;
                  History_Lots = History_Lots + OrderLots();
                  
                  if (OrderLots()>History_MaxLots) History_MaxLots=OrderLots();
                  
                  History_TotalProfitLoss+=OrderProfit()+OrderCommission()+OrderSwap();
                  
                  if (MarketInfo(OrderSymbol(), MODE_DIGITS) <= 3) 
                     pt = 0.01;
                  else 
                     pt = 0.0001;
   
                  
                  if (OrderType()==OP_SELL)
                  {
                     Pips = (OrderOpenPrice()-OrderClosePrice())/pt;
                     if (Pips>=0)
                     {
                        WinPips = WinPips + Pips;
                        WinTrades++;
                     }
                     else
                     {
                        LossPips = LossPips + Pips;
                        LossTrades++;
                     }
                        
                     History_Pips+=Pips;               
                     History_AvgDuration = History_AvgDuration + (OrderCloseTime()-OrderOpenTime());
                  }
                     
                  if (OrderType()==OP_BUY)
                  {
                     Pips = (OrderClosePrice()-OrderOpenPrice())/pt;
                     if (Pips>=0)
                     {
                        WinPips = WinPips + Pips;
                        WinTrades++;
                     }
                     else
                     {
                        LossPips = LossPips + Pips;
                        LossTrades++;
                     }
                     
                     History_Pips+=Pips;
                     History_AvgDuration = History_AvgDuration + (OrderCloseTime()-OrderOpenTime());
                  }  
               }
            }
         }
      }
  }
  
  if (History_TotalTrades>0)
  {
     History_AvgDuration = (History_AvgDuration / History_TotalTrades);
     History_AvgDuration = (History_AvgDuration / 60);
     
     History_WinPerc = (WinTrades*100)/History_TotalTrades;
     History_LossPerc = (LossTrades*100)/History_TotalTrades;
  }

  if (WinTrades>0)  History_WinPips = (WinPips/WinTrades);
  if (LossTrades>0) History_LossPips = (LossPips/LossTrades);
    
  //---------------------------------------------------------------------
}

bool BestEntry(string symbol_name, int type, double pips)
{

   bool   GoodPrice = false;
   double Entry = 0;

   double BestLong;
   double BestShort;
   double WorstLong;
   double WorstShort;
   
   int NrB;
   int NrS;
         

   if (MarketInfo(symbol_name, MODE_DIGITS) <= 3) 
      pt = 0.01;
   else 
      pt = 0.0001;

   for (int cnt = 0; cnt<OrdersTotal();cnt++)
   {     
     if (OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES))
     { 
         if (OrderMagicNumber() == EAmagic && OrderSymbol()==symbol_name) 
         {
            if (OrderType()==OP_BUY)        
            {
               NrB++;
               if (BestLong==0 || OrderOpenPrice()<BestLong) 
               {
                  BestLong=OrderOpenPrice();
               }

               if (WorstLong==0 || OrderOpenPrice()>WorstLong) 
               {
                  WorstLong=OrderOpenPrice();
               }
            }
            
            if (OrderType()==OP_SELL)        
            {
               NrS++;
               if (BestShort==0 || OrderOpenPrice()>BestShort) 
               {
                  BestShort=OrderOpenPrice();
               }

               if (WorstShort==0 || OrderOpenPrice()<WorstShort) 
               {
                  WorstShort=OrderOpenPrice();
               }
            }
         }
      }
   } 


   if (type==OP_BUY)  
   {
      Entry = MarketInfo(symbol_name,MODE_ASK);
      GoodPrice= (BestLong-Entry)/pt>pips || BestLong==0;
   }


   if (type==OP_SELL) 
   {
      Entry = MarketInfo(symbol_name,MODE_BID);
      GoodPrice= (Entry-BestShort)/pt>pips || BestShort==0;
   }   
   
   return(GoodPrice);
}


//--------------------------------------------------------------------------------------------

double MedianPrice(string symbol_name, int OrderKind, double VirtLots, double VirtEntryPrice)
{

  double m=0;
  double t=0; 
  double f=1;
   
  for (int i=OrdersTotal()-1; i>=0; i--)
  {
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
      {

         if (OrderMagicNumber()==EAmagic && OrderSymbol()==symbol_name)
         {   

            if (OrderKind==OP_BUY && OrderType()==OP_BUY)
            {
               f = OrderLots()/0.01;
               t=t+f;
               m=m+(OrderOpenPrice()*f);
            }
            
            if (OrderKind==OP_SELL && OrderType()==OP_SELL)
            {
               f = OrderLots()/0.01;   
               t=t+f;
               m=m+(OrderOpenPrice()*f);
            }         
         }
      }
  }
  
  if (VirtLots>0 && VirtEntryPrice>0)
  {
     f = VirtLots/0.01;   
     t=t+f;
     m=m+(VirtEntryPrice*f);
  }

  if (t>0) 
  { 
    double AvgBsk = m/t;
    return(NormalizeDouble(AvgBsk,MarketInfo(symbol_name,MODE_DIGITS)));
  }
  else
    return(99999);

} 


void BasketStopLoss(string symbol_name, int OrderKind, double SLprice)
{
   
   for (int cnt = OrdersTotal()-1 ; cnt >= 0; cnt--) 
   { 
      if (OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES))
      {
         if (OrderMagicNumber() == EAmagic && OrderSymbol()==symbol_name) 
         { 
            if (OrderType()==OrderKind && OrderStopLoss()!=SLprice)
            {
               OrderModify(OrderTicket(),OrderOpenPrice(),SLprice,OrderTakeProfit(),0,Yellow);          
            }
         }
      }
   }

}


////////////////////////////////////////////////////////////////////////////////////////////////////////
void CloseOldForward()
{ 
      
   int cnt;   
   int total = OrdersTotal()-1;
         
   WaitReadyStatus();
               
   total = OrdersTotal()-1;
   for (cnt = total ; cnt >= 0; cnt--) 
   { 
      if (OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES))
      {

         if (OrderMagicNumber()==EAmagic)
         {   
            if (OrderOpenTime()<StrToTime(CheckHistoryAfter))
            {   

               if (OrderType()==OP_BUY)               
                  OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_BID),2,Blue);
   
               if (OrderType()==OP_SELL)               
                  OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_ASK),2,Red);
            }
         }
         
      }
   }
}


string TFdescription(int tf)
{
   string MTF = "Current";

   switch (tf) 
   { 
      case 0:
         MTF = "Current";
         break; 
         
      case PERIOD_M1: 
         MTF = "M1";
         break; 

      case PERIOD_M5: 
         MTF = "M5";
         break; 

      case PERIOD_M15: 
         MTF = "M15";
         break; 

      case PERIOD_M30: 
         MTF = "M30";
         break; 

      case PERIOD_H1: 
         MTF = "H1";
         break; 

      case PERIOD_H4: 
         MTF = "H4";
         break; 

      case PERIOD_D1: 
         MTF = "D1";
         break; 

      case PERIOD_W1: 
         MTF = "W1";
         break; 

      case PERIOD_MN1: 
         MTF = "MN1";
         break; 

   } 
   
   return(MTF);

}


string PairToTrade(int n)
{   
   if (IsTesting()) 
   {
      if (n==1) 
         return(Symbol());
      else
         return("");
   }
   
   if (n==1)  return(Pair_01);
   if (n==2)  return(Pair_02);
   if (n==3)  return(Pair_03);
   if (n==4)  return(Pair_04);
   if (n==5)  return(Pair_05);
   if (n==6)  return(Pair_06);
   if (n==7)  return(Pair_07);
   if (n==8)  return(Pair_08);
   if (n==9)  return(Pair_09);
   if (n==10) return(Pair_10);
   if (n==11) return(Pair_11);
   if (n==12) return(Pair_12);
   if (n==13) return(Pair_13);
   if (n==14) return(Pair_14);
   if (n==15) return(Pair_15);
   if (n==16) return(Pair_16);
   if (n==17) return(Pair_17);
   if (n==18) return(Pair_18);
   if (n==19) return(Pair_19);
   if (n==20) return(Pair_20);
   if (n==21) return(Pair_21);
   if (n==22) return(Pair_22);
   if (n==23) return(Pair_23);
   if (n==24) return(Pair_24);
   if (n==25) return(Pair_25);
   if (n==26) return(Pair_26);
   if (n==27) return(Pair_27);
   if (n==28) return(Pair_28);

   return("");
}

   
double CalcFloating()
{

  double PL;
  
  for (int i=0; i<OrdersTotal(); i++) 
  {  
      if (OrderSelect(i,SELECT_BY_POS))
      {
         if (OrderMagicNumber()==EAmagic)
         {
            if ((OrderType()==OP_BUY)||(OrderType()==OP_SELL)) 
               PL+=OrderProfit()+OrderCommission()+OrderSwap();
         }
      }
  }         
  
  return(PL);
        
}

datetime OldestPos(string PairName)
{
   
  datetime Oldest;
  
  for(int i=0; i<OrdersTotal(); i++)
  {
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
      {
         if (OrderMagicNumber()!=EAmagic) continue;
                  
         if ((OrderSymbol()==PairName || PairName=="") &&  (OrderType()==OP_BUY || OrderType()==OP_SELL))
         {
            if (OrderOpenTime()<Oldest || Oldest==0)
               Oldest = OrderOpenTime();
         }
      }
  }
   
  return(Oldest);
}


double LinearRegression(int elements)
{
   int i, Np, N0, N1;
   double Sx, Sy, Sxx, Sxy, Syy;

   N0 = 1;
   N1 = elements;
   Np = (N1 - N0) + 1;

   for (i = N0; i<=N1; i++)
   {
       Sx = Sx + i;
       Sy = Sy + MyRegr[i];
       Sxx = Sxx + i * i;
       Sxy = Sxy + i * MyRegr[i];
       Syy = Syy + MyRegr[i] * MyRegr[i];
   }
   
   double den = (Np * Sxx - Sx * Sx);
   if (den!=0)
      return( (Np * Sxy - Sx * Sy) / den );
   
   return(0);
}



////////////////////////////////////////////////////////////////////////////////////////////////////////
void ClosePairList(string symbols_list)
{ 
      
   int cnt;   
   int total = OrdersTotal()-1;
         
   WaitReadyStatus();
               
   total = OrdersTotal()-1;
   for (cnt = total ; cnt >= 0; cnt--) 
   { 
      if (OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES))
      {

         if (StringFind(symbols_list,OrderSymbol())>-1 || symbols_list=="") 
         {      
            if ( OrderMagicNumber()==EAmagic )
            {   

               if (OrderType()==OP_BUY)               
                  OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_BID),2,Blue);

               if (OrderType()==OP_SELL)               
                  OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_ASK),2,Red);

            }
         }  
         
      }
   }
}


int OldestPair(string symbols_list)
{ 
      
   int cnt;   
   int OldestOpen;
   int total = OrdersTotal()-1;
         
   WaitReadyStatus();
               
   total = OrdersTotal()-1;
   for (cnt = total ; cnt >= 0; cnt--) 
   { 
      if (OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES))
      {
         if (StringFind(symbols_list,OrderSymbol())>-1 || symbols_list=="") 
         {      
            if ( OrderMagicNumber()==EAmagic )
            {   
               if (OrderType()==OP_BUY || OrderType()==OP_SELL)               
               {
                  if (OrderOpenTime()<OldestOpen || OldestOpen==0) OldestOpen = OrderOpenTime();
               }
            }
         }    
      }
   }

   return(OldestOpen);
}


void PendingOrderCreate(string symbol_name,int ordType)
{
   double Lmin = MarketInfo(symbol_name,MODE_MINLOT);
   int    tk   = 0;
   double FakePrice;
   
   if (ordType==OP_BUYSTOP ) 
   {
      FakePrice = 9999.00;
      PendingOrderDelete(symbol_name,OP_SELLSTOP);
   }
   
   if (ordType==OP_SELLSTOP) 
   {
      FakePrice = 0.01;
      PendingOrderDelete(symbol_name,OP_BUYSTOP);
   }
      
   while (tk<=0)
   {
      WaitReadyStatus();         
            
      tk = OrderSend(symbol_name,ordType,Lmin,FakePrice,2,0,0,EAcomment,EAmagic,0,clrNONE);
      
      if (!IsTesting()) Print("--->> Trying to Open pending Order on " + symbol_name + " ("+Lmin+ " lots)...");
      
      if (tk<=0) Sleep(250);
   }

}

void PendingOrderDelete(string symbol_name,int ordType)
{
   bool Deleted = false;
   int  cnt;   
   int  total = OrdersTotal()-1;
                        
   total = OrdersTotal()-1;
   for (cnt = total ; cnt >= 0; cnt--) 
   { 
      if (OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES))
      {
         if (OrderType() == ordType && OrderSymbol() == symbol_name && OrderMagicNumber() == EAmagic) 
         {            
            while (!Deleted)
            {
               WaitReadyStatus();         
                     
               Deleted = OrderDelete(OrderTicket());               
               if (!Deleted) Sleep(250);
            }
         }   
      }
   }
}

bool PendingOrderExists(string symbol_name,int ordType)
{
   bool Deleted = false;
   int  cnt;   
   int  total = OrdersTotal()-1;
                        
   total = OrdersTotal()-1;
   for (cnt = total ; cnt >= 0; cnt--) 
   { 
      if (OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES))
      {
         if (OrderType() == ordType && OrderSymbol() == symbol_name && OrderMagicNumber() == EAmagic) 
         {            
            return(true);          
         }   
      }
   }
   
   return(false);          
}


int CloseOrderByTicket(int tk, double lotclose)
{
   string OrdSymb;
   int  c;
   int  NewTicket=0;
   bool TicketClosed=false;

   if (tk>0) 
   {

      for (int try = 1; try<10; try++) 
      {          
         WaitReadyStatus();
   
         TicketClosed=false;
         
         if (OrderSelect(tk,SELECT_BY_TICKET))
         {
            OrdSymb = OrderSymbol();
            
            if (OrderType()==OP_BUY)
               c = Blue;
            else
               c = Red;
      
            if (lotclose>OrderLots()) lotclose = OrderLots();
         
            TicketClosed=OrderClose(OrderTicket(),lotclose,OrderClosePrice(),2,c);
            if (TicketClosed)
            {
         
               NewTicket=-99;
         
               for (int cnt = OrdersTotal()-1 ; cnt >= 0; cnt--) 
               { 
                  if (OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES))
                  {
                     if (OrderSymbol() == OrdSymb && OrderMagicNumber() == EAmagic) 
                     { 
                        if (OrderComment()=="from #"+tk) 
                        {
                           NewTicket=OrderTicket();               
                           break;
                        }
                     }
                  }
               }

            }
            
         }

         if (TicketClosed) 
            break;
         else
            Sleep(80);

      }

   }
   
   return(NewTicket);

}

void ProtectPositions(int type, double ProtectPosMinPips, double ProtectPosUsePips)
{

  double p=0;

  for(int i=0; i<OrdersTotal(); i++)
  {
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
      {
         if (OrderMagicNumber()==EAmagic)
         {

            if (MarketInfo(OrderSymbol(), MODE_DIGITS) <= 3) 
               pt = 0.01;
            else 
               pt = 0.0001;

            p = OrderProfit()+OrderSwap()+OrderCommission();
            
            if (OrderStopLoss()==0 && p>0 && MathAbs(Bid-OrderOpenPrice())/pt>=ProtectPosMinPips)
            {  
 
               if (OrderType()==OP_BUY && type == OP_BUY)
                  OrderModify(OrderTicket(),0,OrderOpenPrice()+ProtectPosUsePips*pt,0,0,Yellow);

               if (OrderType()==OP_SELL && type == OP_SELL)
                  OrderModify(OrderTicket(),0,OrderOpenPrice()-ProtectPosUsePips*pt,0,0,Yellow);
  
            }
         }
      }
  }

}


void MoveToBE(string Pair, int direction, double AvgPrice, double BreakevenPips)
{
   double BreakevenAtProfitPips = BreakevenPips;
   int pos=0;


   if (MarketInfo(Pair, MODE_DIGITS) <= 3) 
      pt = 0.01;
   else 
      pt = 0.0001;

   if (StringFind(Pair,"XAU")>-1)
      pt = 0.10;   

   double SL;

   int stoplevel    = SymbolInfoInteger(Pair,SYMBOL_TRADE_STOPS_LEVEL);
   int spread       = SymbolInfoInteger(Pair,SYMBOL_SPREAD);   
   
   double price_BID = MarketInfo(Pair,MODE_BID);   
   double price_ASK = MarketInfo(Pair,MODE_ASK);  
   double points    = MarketInfo(Pair,MODE_POINT);  
   
   for (pos = OrdersTotal()-1; pos >= 0 ; pos--) 
   {
      bool check = OrderSelect(pos, SELECT_BY_POS);
      
      if (check && OrderMagicNumber()==EAmagic && OrderSymbol()==Pair)
      {
         if (direction==OP_BUY && OrderType()==OP_BUY && price_BID>ND(Pair,AvgPrice+BreakevenPips*pt)&&(OrderStopLoss()<ND(Pair,AvgPrice+BreakevenAtProfitPips*pt) || OrderStopLoss()==0))
         {
            SL = ND(Pair,AvgPrice+BreakevenAtProfitPips*pt);
            if (price_ASK-SL>=stoplevel*points)
            {  
               check=OrderModify(OrderTicket(),OrderOpenPrice(),SL,OrderTakeProfit(),0,Blue);
            }
         }
         if (direction==OP_SELL && OrderType()==OP_SELL && price_ASK<ND(Pair,AvgPrice-BreakevenPips*pt)&&(OrderStopLoss()>ND(Pair,AvgPrice-BreakevenAtProfitPips*pt) || OrderStopLoss()==0))
         {
            SL = ND(Pair,AvgPrice-BreakevenAtProfitPips*pt);
            if (SL-price_BID >= stoplevel*points)
            { 
               check=OrderModify(OrderTicket(),OrderOpenPrice(),SL,OrderTakeProfit(),0,Red);
            }
         }
      }
   }
}

double ND(string symbol_name, double val)
{
   int d = MarketInfo(symbol_name,MODE_DIGITS);
   
   return(NormalizeDouble(val,d));
}

void CloseAllBasket()
{ 
      
   int cnt;   
   int total = OrdersTotal()-1;
         
   WaitReadyStatus();
               
   total = OrdersTotal()-1;
   for (cnt = total ; cnt >= 0; cnt--) 
   { 
      if (OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES))
      {

         if ( OrderMagicNumber()==EAmagic )
         {   

            if (OrderType()==OP_BUY)               
               OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_BID),2,Blue);

            if (OrderType()==OP_SELL)               
               OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_ASK),2,Red);

         }
         
      }
   }
}

void HiddenTrailing(string symbol_name, string Type)
{

   if (MarketInfo(symbol_name, MODE_DIGITS) <= 3) 
      pt = 0.01;
   else 
      pt = 0.0001;


   double autoTS_Start = Trailing_Start;
   double autoTS       = Trailing_Step;
   
   double NewSL;
   
   if (Type=="LONG")
   {
      double SLBNew = GetLine(symbol_name,OP_BUY);
      NewSL         = NormalizeDouble((MarketInfo(symbol_name,MODE_BID))-autoTS*pt,MarketInfo(symbol_name,MODE_DIGITS));
      
      if (NewSL>SLBNew && MarketInfo(symbol_name,MODE_BID)-(autoTS_Start+autoTS)*pt>=mpb)
      { 
         SetLine(symbol_name,OP_BUY,NewSL);
         BasketStopLoss(symbol_name,OP_BUY,NewSL);
      }
   }
   
   if (Type=="SHORT")
   {   
      double SLSNew = GetLine(symbol_name,OP_SELL); 
      NewSL         = NormalizeDouble((MarketInfo(symbol_name,MODE_ASK))+autoTS*pt,MarketInfo(symbol_name,MODE_DIGITS));
      
      if (SLSNew-(MarketInfo(symbol_name,MODE_ASK))>autoTS*pt && mps-((MarketInfo(symbol_name,MODE_ASK)))>=(autoTS_Start+autoTS)*pt)
      { 
         SetLine(symbol_name,OP_SELL,NewSL);
         BasketStopLoss(symbol_name,OP_SELL,NewSL);
      }
   }
}

void CheckValidSL()
{
  string OrdSY="";
  int    OrdTY=0;
  int    OrdTK=0; 
  int    total=0;
  
  for (int i=0; i<OrdersTotal(); i++)
  {
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
      {
         if (OrderMagicNumber()==EAmagic)
         {
            if (OrderStopLoss()==0)
            {
               OrdTK = OrderTicket();
               OrdTY = OrderType();
               OrdSY = OrderSymbol();
               
               if (MarketInfo(OrderSymbol(), MODE_DIGITS) <= 3) 
                  pt = 0.01;
               else 
                  pt = 0.0001;
   
               if (OrdTY==OP_BUY)
               {                  
                  mpb = MedianPrice(OrdSY,OP_BUY,0,0);
                  if (!OrderModify(OrdTK,0,mpb-SLpips*pt,mpb+TPpips*pt,0,Yellow))
                     Alert("WARNING: Cannot set SL on "+OrdSY+" !!!");
               }
         
               if (OrdTY==OP_SELL)
               {
                  mps = MedianPrice(OrdSY,OP_SELL,0,0);
                  if (!OrderModify(OrdTK,0,mps+SLpips*pt,mps-TPpips*pt,0,Yellow))
                     Alert("WARNING: Cannot set SL on "+OrdSY+" !!!");
               }
            }
         }
      }
  }
  
  return;
}

int GetStochTrend(string symbol_name, int shift)
{

   int r = -9999;
   int s = shift;
   
   double StoMain = iStochastic(symbol_name, Entry_Stoch_TF, Entry_Stoch_K, Entry_Stoch_D, Entry_Stoch_Slow, MODE_SMA, 0, MODE_MAIN  , s);
   double StoSign = iStochastic(symbol_name, Entry_Stoch_TF, Entry_Stoch_K, Entry_Stoch_D, Entry_Stoch_Slow, MODE_SMA, 0, MODE_SIGNAL, s);

   if (StoMain > StoSign)  r = OP_BUY;   
   if (StoMain < StoSign)  r = OP_SELL;
   
   return (r);  

}
